// Simple SQL access program that uses a command-line argument to build
// the SQL.  This program is vulnerable to SQL injection attacks.
//
// Run this program like:
// ./bblookup 'Willie McGee'
//
// Documentation on programming PostgreSQL from C/C++ is at:
// http://www.postgresql.org/docs/8.3/interactive/libpq.html
//
// This code is released under the GNU Public License
// The full text of the license is available at:
// http://www.gnu.org/copyleft/gpl.html

#include "pgsql/libpq-fe.h"
#include "iostream"
#include "string"
#include <err.h>

using namespace std;

int main(int argc, char *argv[])
{
    if (argc != 2)
        errx(1, "Usage: %s name\nOne valid name is 'Willie McGee'", argv[0]);

    PGconn *dbcon;
    PGresult *res;

    dbcon = PQconnectdb("host=localhost dbname=baseball user=fan password=baseball");
    if (PQstatus(dbcon) != CONNECTION_OK)
	errx(1, "Connection to database failed: %s", PQerrorMessage(dbcon));

    res = PQexecParams(dbcon, "SELECT name, hits86 FROM hitter where name = $1", 1, NULL, &argv[1], NULL, NULL, 0);
    if (PQresultStatus(res) == PGRES_TUPLES_OK) {
	int n = PQntuples(res);
	for (int i=0; i<n; i++) {
	    cout << PQgetvalue(res, i, 0) << ": ";
	    cout << PQgetvalue(res, i, 1) << endl;
	}
    } else {
        errx(1, "PQexec failed: %s", PQresultErrorMessage(res));
    }
    PQclear(res);
    PQfinish(dbcon);

    return 0;
}
