// Simple SQL access program that uses a command-line argument to build
// the SQL.  This program is uses parameterized queries to reduce its
// vulnerability to SQL injection attacks.
//
// This code is released under the GNU Public License
// The full text of the license is available at:
// http://www.gnu.org/copyleft/gpl.html

import java.sql.*;
import java.io.*;

public class bblookup {
    public static void main(String[] args)
        throws ClassNotFoundException, SQLException
    {
	Connection dbcon;
	PreparedStatement p_sqlstmt;
	ResultSet wps;
	String sql;

	// Ensure we were called properly
	if (args.length != 1) {
	    System.err.println("Usage: Java bblookup name");
	    System.err.println("One valid name is 'Willie McGee'");
	    System.exit(1);
	}

	Class.forName("org.postgresql.Driver");
	// You will probably need to change the host from "localhost"
	dbcon = DriverManager.getConnection("jdbc:postgresql://localhost/baseball",
	                      "fan", "baseball");
	p_sqlstmt = dbcon.prepareStatement(
	    "SELECT name, hits86 FROM hitter where name = ?;"
	);
	p_sqlstmt.setString(1, args[0]);
	wps = p_sqlstmt.executeQuery();
	while (wps.next()) {
	    System.out.println(wps.getString("name") + ": " + wps.getString("hits86"));
	}
	dbcon.close();
    }
}
